import { world, system } from '@minecraft/server';
import { ActionFormData } from '@minecraft/server-ui';

system.runInterval(() => {
    for (const player of world.getAllPlayers()) {
        const sculkexp = player.level
        const scoresct = world.scoreboard.getObjective("ctlbs")
        const item = player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex);
        if (player.hasTag('chorus_armour'))
            if (player.getEffect('levitation'))
                player.removeEffect('levitation')
        if (player.hasTag('witheri_armour'))
            if (player.getEffect('wither'))
                player.removeEffect('wither')
        if (player.hasTag('sculk_armour'))
            if (player.getEffect('darkness'))
                player.removeEffect('darkness')
        if (player.hasTag('soul_armor'))
            if (player.getEffect('slowness'))
                player.removeEffect('slowness')
        if (player.hasTag('redstonerock_armour')) {
            if (player.isSprinting)
                player.runCommand('scoreboard players add @s redrocksprint 1')
            if (player.isSprinting == false)
                player.runCommand('scoreboard players reset @s redrocksprint')
        }
        if (player.hasTag('sculkexpdouble'))
            player.runCommand(`xp ${sculkexp}L @s`)
        if (player.hasTag('creaking_armor'))
            if (player.isSneaking)
                player.runCommand('titleraw @s actionbar {"rawtext": [{"text":"§6"}, {"score":{"name":"@s", "objective":"resinshield"}}, {"text":"§8/§620"}]}')
        if (player.hasTag('coppertuff_armor'))
            if (player.hasTag('ctlbs'))
                player.runCommand(`effect @s strength 1 ${scoresct.getScore(player) - 1} true`)
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item.typeId.startsWith('alloys:') == false) {
                if (item?.hasTag("minecraft:wooden_tier"))
                    player.runCommand('tag @s add alloypickaxetiers1');
                if (item?.hasTag("minecraft:golden_tier"))
                    player.runCommand('tag @s add alloypickaxetiers1');
                if (item?.hasTag("minecraft:stone_tier"))
                    player.runCommand('tag @s add alloypickaxetiers1');
                if (item?.hasTag("minecraft:iron_tier"))
                    player.runCommand('tag @s add alloypickaxetiers1');
                if (item?.hasTag("minecraft:diamond_tier"))
                    player.runCommand('tag @s add alloypickaxetiers1');
                if (item?.hasTag("minecraft:diamond_tier"))
                    player.runCommand('tag @s add alloypickaxetiers2');
                if (item?.hasTag("minecraft:netherite_tier"))
                    player.runCommand('tag @s add alloypickaxetiers1');
                if (item?.hasTag("minecraft:netherite_tier"))
                    player.runCommand('tag @s add alloypickaxetiers2');
            }
        if (item?.hasTag("minecraft:netherite_tier") == false)
            if (item?.hasTag("minecraft:diamond_tier") == false)
                if (item?.hasTag("minecraft:iron_tier") == false)
                    if (item?.hasTag("minecraft:stone_tier") == false)
                        if (item?.hasTag("minecraft:golden_tier") == false)
                            if (item?.hasTag("minecraft:wooden_tier") == false)
                                player.runCommand('tag @s remove alloypickaxetiers1');
        if (item?.hasTag("minecraft:netherite_tier") == false)
            if (item?.hasTag("minecraft:diamond_tier") == false)
                player.runCommand('tag @s remove alloypickaxetiers2');
    };
});

world.afterEvents.playerBreakBlock.subscribe(durabilitytool => {
    const player = durabilitytool.player;
    const item = durabilitytool.itemStackAfterBreak;
    const durability = item.getComponent("durability").maxDurability;
    const damage = item.getComponent("durability").damage;
    const inventory = player.getComponent('inventory').container;
    if (item?.hasTag("minecraft:is_tool"))
        if (player.hasTag('alloyscreative') == false)
            if (item.typeId.startsWith('alloys:'))
                if (damage == durability) {
                    inventory.setItem(player.selectedSlotIndex, null);
                } else {
                    item.getComponent("durability").damage += 1;
                    inventory.setItem(player.selectedSlotIndex, item);
                }
});
world.afterEvents.playerBreakBlock.subscribe(durabilityweaponmine => {
    const player = durabilityweaponmine.player;
    const item = durabilityweaponmine.itemStackAfterBreak;
    const durability = item.getComponent("durability").maxDurability;
    const damage = item.getComponent("durability").damage;
    const inventory = player.getComponent('inventory').container;
    if (item?.hasTag("minecraft:is_sword"))
        if (player.hasTag('alloyscreative') == false)
            if (item.typeId.startsWith('alloys:'))
                if (damage == durability) {
                    inventory.setItem(player.selectedSlotIndex, null);
                } else {
                    item.getComponent("durability").damage += 1;
                    inventory.setItem(player.selectedSlotIndex, item);
                }
});
world.afterEvents.entityHurt.subscribe(durabilityhit => {
    const player = durabilityhit.damageSource.damagingEntity;
    const item = player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex);
    const durability = item.getComponent("durability").maxDurability;
    const damage = item.getComponent("durability").damage;
    const inventory = player.getComponent('inventory').container;
    if (item?.hasTag("minecraft:is_tool"))
        if (player.hasTag('alloyscreative') == false)
            if (item.typeId.startsWith('alloys:'))
                if (damage == durability) {
                    inventory.setItem(player.selectedSlotIndex, null);
                } else {
                    item.getComponent("durability").damage += 1;
                    inventory.setItem(player.selectedSlotIndex, item);
                }
});
world.afterEvents.itemUse.subscribe(durabilityuse => {
    const player = durabilityuse.source;
    const item = durabilityuse.itemStack;
    const durability = item.getComponent("durability").maxDurability;
    const damage = item.getComponent("durability").damage;
    const inventory = player.getComponent('inventory').container;
    if (item?.hasTag("minecraft:is_sword"))
        if (player.hasTag('alloyscreative') == false)
            if (item.typeId.startsWith('alloys:'))
                if (damage == durability) {
                    inventory.setItem(player.selectedSlotIndex, null)
                } else {
                    item.getComponent("durability").damage += 1
                    inventory.setItem(player.selectedSlotIndex, item)
                }
});
world.afterEvents.playerBreakBlock.subscribe(alloysblocks => {
    const player = alloysblocks.player;
    const item = alloysblocks.itemStackAfterBreak;
    const block = alloysblocks.brokenBlockPermutation;
    const blockcommand = alloysblocks.dimension;
    const location = alloysblocks.block;
    const x = Math.round(location.x);
    const y = Math.round(location.y);
    const z = Math.round(location.z);
    if (world.gameRules.doTileDrops == true) {
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:alloys_maker')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/alloys_maker"`);
        if (player.hasTag('alloypickaxetiers1'))
            if (block.type.id == 'alloys:alloys_maker')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/alloys_maker"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:equipment_workbench')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/equipment_workbench"`);
        if (player.hasTag('alloypickaxetiers1'))
            if (block.type.id == 'alloys:equipment_workbench')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/equipment_workbench"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:amethyst_gold_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/amethyst_gold"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:amethyst_gold_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/amethyst_gold"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:ancient_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/ancient"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:ancient_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/ancient"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:blazing_glow_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/blazing_glow"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:blazing_glow_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/blazing_glow"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:cherry_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/cherry"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:cherry_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/cherry"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:chorus_shulker_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/chorus_shulker"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:chorus_shulker_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/chorus_shulker"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:copper_tuff_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/copper_tuff"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:copper_tuff_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/copper_tuff"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:creaking_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/creaking"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:creaking_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/creaking"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:crimson_wart_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/crimson_wart"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:crimson_wart_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/crimson_wart"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:dragon_obsidian_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/dragon_obsidian"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:dragon_obsidian_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/dragon_obsidian"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:elf_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/elf"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:elf_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/elf"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:ember_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/ember"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:ember_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/ember"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:endstone_quartz_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/endstone_quartz"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:endstone_quartz_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/endstone_quartz"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:flaming_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/flaming"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:flaming_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/flaming"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:gemmy_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/gemmy"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:gemmy_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/gemmy"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:icy_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/icy"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:icy_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/icy"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:mana_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/mana"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:mana_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/mana"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:oceanic_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/oceanic"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:oceanic_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/oceanic"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:redstone_rock_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/redstone_rock"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:redstone_rock_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/redstone_rock"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:sculk_steel_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/sculk_steel"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:sculk_steel_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/sculk_steel"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:soul_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/soul"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:soul_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/soul"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:storm_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/storm"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:storm_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/storm"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:warped_wart_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/warped_wart"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:warped_wart_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/warped_wart"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:watcher_alloy_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/watcher"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:watcher_alloy_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/watcher"`);
        if (item?.hasTag("minecraft:is_pickaxe"))
            if (item?.typeId.startsWith('alloys:'))
                if (block.type.id == 'alloys:wither_iron_block')
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/wither_iron"`);
        if (player.hasTag('alloypickaxetiers2'))
            if (block.type.id == 'alloys:wither_iron_block')
                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "alloys_blocks/wither_iron"`);
    }
});
world.afterEvents.entityHurt.subscribe(abilityswords => {
    const player = abilityswords.damageSource.damagingEntity;
    const target = abilityswords.hurtEntity;
    var damage = abilityswords.damage;
    const item = player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex);
    if (item?.hasTag("minecraft:is_sword")) {
        if (world.gameRules.doMobLoot == true) {
            if (item?.typeId.startsWith('alloys:crimson_wart_'))
                target.runCommand('function crim_weapon');
            if (item?.typeId.startsWith('alloys:gemmy_'))
                target.runCommand('function g_loot');
            if (item?.typeId.startsWith('alloys:sculk_'))
                player.runCommand('function s_weapon');
        }
        if (item?.typeId.startsWith('alloys:ancient_'))
            target.runCommand('function anc_weapon');
        if (item?.typeId.startsWith('alloys:blazing_'))
            player.runCommand('function b_weapon');
        if (item?.typeId.startsWith('alloys:cherry_'))
            player.runCommand('function cherry_weapon');
        if (item?.typeId.startsWith('alloys:chorus_shulker_'))
            player.runCommand('function c_weapon_1');
        if (item?.typeId.startsWith('alloys:endstone_quartz_'))
            target.runCommand('function e_weapon');
        if (item?.typeId.startsWith('alloys:ember_'))
            if (item?.getComponent('minecraft:enchantable').hasEnchantment('minecraft:fire_aspect'))
                target.applyDamage(damage + 4);
        if (item?.typeId.startsWith('alloys:flaming_'))
            target.setOnFire(20, true);
        if (item?.typeId.startsWith('alloys:gilded_amethyst_'))
            player.runCommand('function a_weapon');
        if (item?.typeId.startsWith('alloys:icy_'))
            target.runCommand('function i_weapon');
        if (item?.typeId.startsWith('alloys:mana_'))
            target.runCommand('function m_weapon');
        if (item?.typeId.startsWith('alloys:oceanic_'))
            target.runCommand('function o_weapon');
        if (item?.typeId.startsWith('alloys:redstone_rock_'))
            player.runCommand('function redstone_weapon');
        if (item?.typeId.startsWith('alloys:soul_'))
            target.runCommand('function soul_weapon');
        if (item?.typeId.startsWith('alloys:soul_'))
            player.runCommand('function soul_weapon_1');
        if (item?.typeId.startsWith('alloys:warped_wart_'))
            player.runCommand('function warp_weapon');
        if (item?.typeId.startsWith('alloys:watcher_'))
            target.runCommand('function watch_weapon');
        if (item?.typeId.startsWith('alloys:creaking_'))
            target.runCommand('scoreboard players random @s creaksword 1 10');
        if (item?.typeId.startsWith('alloys:creaking_'))
            target.runCommandAsync('effect @s[scores={creaksword=1..3}] wither 6 3');
        if (item?.typeId.startsWith('alloys:storm_')) {
            if (target.isOnGround == false)
                target.applyDamage(damage + 2);
            if (target.isOnGround)
                player.runCommand('effect @s weakness 2 4 true');
        }
        if (item?.typeId.startsWith('alloys:copper_tuff_')) {
            target.runCommand('scoreboard players random @s ctweakness 1 2');
            target.runCommandAsync('effect @s[scores={ctweakness=1}] weakness 4 2');
        }

    }
    if (item?.hasTag("minecraft:is_tool"))
        if (item?.hasTag("minecraft:is_sword") == false) {
            if (item?.typeId.startsWith('alloys:flaming_'))
                target.setOnFire(20, true);

        }
    world.afterEvents.entityHealthChanged.subscribe(abilityhealth => {
        const nv = abilityhealth.newValue > 34;
        if (item?.hasTag("minecraft:is_sword"))
            if (item?.typeId.startsWith('alloys:dragon_obsidian_'))
                if (nv)
                    target.applyDamage(damage + 4);
    });
    if (player.hasTag('coppertuff_armor')) {
        player.runCommand('effect @s hunger 3 7 true');
        target.runCommand('scoreboard players add @s ctlgnbl 1');
        if (target.hasTag('ctlgnbl'))
            player.runCommand('scoreboard players add @s ctlbs 1');
        if (target.hasTag('ctlgnbl'))
            target.runCommand('scoreboard players set @s ctlgnbl 0');
    }
});
world.afterEvents.entityDie.subscribe(abilitydie => {
    const target = abilitydie.deadEntity;
    const player = abilitydie.damageSource.damagingEntity;
    const item = player.getComponent("minecraft:inventory").container.getItem(player.selectedSlotIndex);
    if (item?.hasTag("minecraft:is_sword")) {
        if (item?.typeId.startsWith('alloys:wither_iron_'))
            if (world.gameRules.doMobLoot == true)
                target.runCommand('execute if entity @s[type=wither_skeleton] run function w_weapon');
        if (item?.typeId.startsWith('alloys:creaking_'))
            player.runCommand('scoreboard players add @s[scores={resinshield=..19}] resinshield 1');
    }
    if (world.gameRules.doMobLoot == true)
        if (player.hasTag('sculk_armour'))
            player.runCommand('scoreboard players random @s sculkexp 1 200');
    if (player.hasTag('creaking_armor'))
        player.runCommand('scoreboard players add @s[scores={resinshield=..19}] resinshield 4');
    if (player.hasTag('coppertuff_armor'))
        player.runCommand('effect @s saturation 1 2 true');
});
world.afterEvents.itemUse.subscribe(abilityuse => {
    const player = abilityuse.source;
    const item = abilityuse.itemStack;
    if (item?.hasTag("minecraft:is_sword"))
        if (item?.typeId.startsWith('alloys:elf_'))
            player.runCommand('effect @s regeneration 4 2 true');
    if (item?.typeId == 'minecraft:resin_clump') {
        player.runCommand('scoreboard players add @s[scores={resinshield=..19}] resinshield 2');
        player.runCommand('clear @s[scores={resinshield=..19}] resin_clump 0 1');
    }
    if (item?.typeId == 'minecraft:resin_brick') {
        player.runCommand('scoreboard players add @s[scores={resinshield=..19}] resinshield 2');
        player.runCommand('clear @s[scores={resinshield=..19}] resin_brick 0 1');
    }
});
world.afterEvents.itemUseOn.subscribe(abilityuseon => {
    const player = abilityuseon.source;
    const item = abilityuseon.itemStack;
    if (item?.typeId == 'minecraft:resin_clump') {
        player.runCommand('scoreboard players remove @s[scores={resinshield=..19}] resinshield 2');
        player.runCommand('give @s[scores={resinshield=..19}] resin_clump');
    }
})
world.afterEvents.playerBreakBlock.subscribe(abilitytools => {
    const player = abilitytools.player;
    const item = abilitytools.itemStackAfterBreak;
    const block = abilitytools.brokenBlockPermutation;
    const blockcommand = abilitytools.dimension;
    const location = abilitytools.block;
    const silktouch = item?.getComponent("minecraft:enchantable").hasEnchantment('minecraft:silk_touch')
    const x = Math.round(location.x);
    const y = Math.round(location.y);
    const z = Math.round(location.z);

    if (item?.hasTag("minecraft:is_tool"))
        if (item?.hasTag("minecraft:is_sword") == false) {
            if (world.gameRules.doTileDrops == true) {
                if (item?.typeId.startsWith('alloys:ancient_'))
                    player.runCommand('scoreboard players random @s ancientsherd 1 10');
                if (item?.typeId.startsWith('alloys:ancient_'))
                    if (player.hasTag('ancientsherd'))
                        blockcommand.runCommandAsync(`loot spawn ${x} ${y} ${z} loot "sherd"`);
                if (item?.typeId.startsWith('alloys:crimson_wart_'))
                    if (block.type.id.includes('gold'))
                        if (block.type.id.includes('ore'))
                            if (silktouch == false)
                                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "crimson_wart"`);
                if (item?.typeId.startsWith('alloys:gemmy_'))
                    blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "gemmy"`);
                if (item?.typeId.startsWith('alloys:warped_wart_'))
                    if (block.type.id.includes('diamond'))
                        if (block.type.id.includes('ore'))
                            if (silktouch == false)
                                blockcommand.runCommand(`loot spawn ${x} ${y} ${z} loot "warped_wart"`);
            }
            if (item?.typeId.startsWith('alloys:cherry_'))
                player.runCommand(`function cherry_tool`);
            if (item?.typeId.startsWith('alloys:gilded_amethyst_'))
                player.runCommand('function a_tool');
        }
    if (item?.hasTag("minecraft:is_tool"))
        if (item?.typeId.startsWith('alloys:redstone_rock_'))
            player.runCommand('function redstone_tool');
    if (world.gameRules.doTileDrops == true)
        if (item?.hasTag("minecraft:is_tool"))
            if (item?.typeId.startsWith('alloys:sculk_'))
                blockcommand.runCommand(`summon xp_orb ${x} ${y} ${z}`);
    if (item?.hasTag("minecraft:is_tool"))
        if (item?.typeId.startsWith('alloys:creaking_'))
            player.runCommand('scoreboard players add @s[scores={resinshield=..19}] resinshield 1');
    if (world.gameRules.doTileDrops == true)
        if (player.hasTag('gemmy_armor'))
            if (block.type.id == 'minecraft:emerald_block')
                blockcommand.runCommandAsync(`loot spawn ${x} ${y} ${z} loot "gemmyemerald"`);
});
world.afterEvents.entityHurt.subscribe(amabilhurt => {
    const player = amabilhurt.hurtEntity
    const target = amabilhurt.damageSource.damagingEntity
    const projectile = amabilhurt.damageSource.damagingProjectile
    const damage = amabilhurt.damage
    const damagec = amabilhurt.damageSource.cause.match("fall")
    const scoreswatcher = world.scoreboard.getObjective("watcherhurt")
    if (player.hasTag('amethyst'))
        target.runCommand(`damage @s ${Math.round((damage * 0.25) + 2)} thorns`)
    if (player.hasTag('watcheramour')) {
        player.runCommand('execute at @e[r=32, family=!inanimate, rm=0.5] run scoreboard players add @s watcherhurt 1')
        player.runCommandAsync(`damage @e[r=32, family=!inanimate, rm=0.5] ${scoreswatcher.getScore(player)} entity_attack`)
        player.runCommandAsync('scoreboard players reset @s watcherhurt')
    }
    if (player.hasTag('creaking_armor'))
        if (player.hasTag('resinshield'))
            if (player.hasTag('resinshieldcd') == false) {
                if (player.hasTag('resinshieldstrong') == false)
                    target.runCommand(`damage @s 2 wither`)
                if (player.hasTag('resinshieldstrong'))
                    target.runCommand(`damage @s 3 wither`)
                if (player.hasTag('resinshieldstrong') == false)
                    target.runCommand('effect @s wither 4 2')
                if (player.hasTag('resinshieldstrong'))
                    target.runCommand('effect @s wither 5 2')
            }
    if (player.hasTag('stormfall'))
        if (damagec) {
            player.applyDamage(damage * 2)
            player.runCommandAsync('tag @s remove stormfall')
        }
});
world.afterEvents.entityHealthChanged.subscribe(amabilhealth => {
    const player = amabilhealth.entity
    const nh1 = amabilhealth.newValue > 10
    const nh2 = amabilhealth.newValue <= 10
    if (player.hasTag('creaking_armor'))
        if (player.hasTag('resinshield'))
            if (player.hasTag('resinshieldcd') == false) {
                if (nh1)
                    player.runCommand('scoreboard players remove @s resinshield 2')
                if (nh2)
                    player.runCommand('scoreboard players remove @s resinshield 1')
            }
});
world.afterEvents.entityHurt.subscribe(stormfall => {
    const player = stormfall.hurtEntity
    const damage = stormfall.damage
    const damagec = stormfall.damageSource.cause.match("fall")
    if (player.hasTag('stormfall'))
        if (damagec) {
            player.applyDamage((damage + 2) * 2)
            player.runCommand('tag @s remove stormfall')
        }
});
world.afterEvents.entityHitEntity.subscribe(ambilattack => {
    const player = ambilattack.damagingEntity
    const target = ambilattack.hitEntity
    if (player.hasTag('flaming_armour'))
        target.setOnFire(3, true)
    if (player.hasTag('storm_armor')) {
        target.applyKnockback(0, 0, 0, 1.05)
        target.runCommand('execute at @s run summon alloys:stormknockback ~~~')
        target.runCommand('execute at @s run particle minecraft:wind_explosion_emitter ~~~')
        player.runCommand('tag @s add stormknock')
        target.runCommand('tag @s add stormfall')
    }
});
world.beforeEvents.worldInitialize.subscribe((components) => {
    const { itemComponentRegistry } = components
    itemComponentRegistry.registerCustomComponent("alloys:use", {
        onUseOn: (components) => {
            const player = components.source;
            const item = components.itemStack;
            const block = components.usedOnBlockPermutation;
            const location = components.block;
            const x = location.x;
            const y = location.y;
            const z = location.z;
            if (item.typeId.startsWith('alloys:'))
                if (item.typeId.endsWith('_shovel')) {
                    if (block.type.id == 'minecraft:grass_block')
                        location.dimension.runCommand(`setblock ${x} ${y} ${z} grass_path`);
                    if (block.type.id == 'minecraft:dirt')
                        location.dimension.runCommand(`setblock ${x} ${y} ${z} grass_path`);
                    if (block.type.id == 'minecraft:coarse_dirt')
                        location.dimension.runCommand(`setblock ${x} ${y} ${z} grass_path`);
                    if (block.type.id == 'minecraft:dirt_with_roots')
                        location.dimension.runCommand(`setblock ${x} ${y} ${z} grass_path`);
                    if (block.type.id == 'minecraft:podzol')
                        location.dimension.runCommand(`setblock ${x} ${y} ${z} grass_path`);
                    if (block.type.id == 'minecraft:mycelium')
                        location.dimension.runCommand(`setblock ${x} ${y} ${z} grass_path`);
                    if (block.type.id == 'minecraft:snow_layer')
                        location.dimension.runCommand(`setblock ${x} ${y} ${z} air [] destroy`);
                }
        }
    })
});

world.afterEvents.itemUse.subscribe(alloys => {
    if (alloys.itemStack.typeId !== 'alloys:alloys_forging_book') return;
    AlloysMenu(alloys.source);
});
function AlloysMenu(player) {
    const button = new ActionFormData
    button.title("§6§lAlloys Forging Book")
        .button("§3Introduction", "textures/items/alloys_forging_book")
        .button("§3Alloys", "textures/items/sculk_steel_alloy")
        .button("§3Blocks", "textures/blocks/ember_alloy_block")
        .button("§3Equipment", "textures/items/dragon_obsidian_chestplate")
        .button("§3V8.0 Changelog", "textures/ui/changelog")
        .button("§3V8.1 Changelog", "textures/ui/changelog")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Introduction(player);
        if (selection.selection == 1)
            Alloys(player);
        if (selection.selection == 2)
            Blocks(player);
        if (selection.selection == 3)
            Equipment(player);
        if (selection.selection == 4)
            Changelog1(player);
        if (selection.selection == 5)
            Changelog2(player);
        if (selection.canceled) return;
    })
};
function Introduction(player) {
    const button = new ActionFormData
    button.title("§6§lIntroduction")
        .body("§8Thanks for downloading this addon! This book will guide you to craft those amazing and powerful gears. This book is craftable so you can craft it again if needed. You can also put this book inside Chiseled Bookshelves to save your Chests space.\n\n\n\n\n\n\n\n")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            AlloysMenu(player);
        if (selection.canceled) return;
    })
};
function Equipment(player) {
    const button = new ActionFormData
    button.title("§6§lEquipment")
        .button("§3Ancient", "textures/items/ancient_chestplate")
        .button("§3Blazing Glow", "textures/items/blazing_glow_chestplate")
        .button("§3Cherry", "textures/items/cherry_chestplate")
        .button("§3Chorus Shulker", "textures/items/chorus_shulker_chestplate")
        .button("§3Copper Tuff", "textures/items/copper_tuff_chestplate")
        .button("§3Creaking", "textures/items/creaking_chestplate")
        .button("§3Crimson Wart", "textures/items/crimson_wart_chestplate")
        .button("§3Dragon Obsidian", "textures/items/dragon_obsidian_chestplate")
        .button("§3Elf", "textures/items/elf_chestplate")
        .button("§3Ember", "textures/items/ember_chestplate")
        .button("§3Endstone Quartz", "textures/items/endstone_quartz_chestplate")
        .button("§3Flaming", "textures/items/flaming_chestplate")
        .button("§3Gemmy", "textures/items/gemmy_chestplate")
        .button("§3Gilded Amethyst", "textures/items/gilded_amethyst_chestplate")
        .button("§3Icy", "textures/items/icy_chestplate")
        .button("§3Mana", "textures/items/mana_chestplate")
        .button("§3Oceanic", "textures/items/oceanic_chestplate")
        .button("§3Redstone Rock", "textures/items/redstone_rock_chestplate")
        .button("§3Sculk", "textures/items/sculk_chestplate")
        .button("§3Soul", "textures/items/soul_chestplate")
        .button("§3Storm", "textures/items/storm_chestplate")
        .button("§3Warped Wart", "textures/items/warped_wart_chestplate")
        .button("§3Watcher", "textures/items/watcher_chestplate")
        .button("§3Wither Iron", "textures/items/wither_iron_chestplate")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Ancient(player);
        if (selection.selection == 1)
            BlazingGlow(player);
        if (selection.selection == 2)
            Cherry(player);
        if (selection.selection == 3)
            ChorusShulker(player);
        if (selection.selection == 4)
            CopperTuff(player);
        if (selection.selection == 5)
            Creaking(player);
        if (selection.selection == 6)
            CrimsonWart(player);
        if (selection.selection == 7)
            DragonObsidian(player);
        if (selection.selection == 8)
            Elf(player);
        if (selection.selection == 9)
            Ember(player);
        if (selection.selection == 10)
            EndstoneQuartz(player);
        if (selection.selection == 11)
            Flaming(player);
        if (selection.selection == 12)
            Gemmy(player);
        if (selection.selection == 13)
            GildedAmethyst(player);
        if (selection.selection == 14)
            Icy(player);
        if (selection.selection == 15)
            Mana(player);
        if (selection.selection == 16)
            Oceanic(player);
        if (selection.selection == 17)
            RedstoneRock(player);
        if (selection.selection == 18)
            Sculk(player);
        if (selection.selection == 19)
            Soul(player);
        if (selection.selection == 20)
            Storm(player);
        if (selection.selection == 21)
            WarpedWart(player);
        if (selection.selection == 22)
            Watcher(player);
        if (selection.selection == 23)
            WitherIron(player);
        if (selection.selection == 24)
            AlloysMenu(player);
        if (selection.canceled) return;
    })
};
function Ancient(player) {
    const button = new ActionFormData
    button.title("§6§lAncient")
        .body("§8§lArmour Ability\n§r§a§2+ §aRegeneration II and Resistance IV.\n§2+ §aGain Speed II while stepping on Stones, Cobblestones, Deepslates, Cobbled Deepslates, Granites, Diorites and Andesites.\n§4- §cBad Omen III.\n§4- §cWhile staying in lava, wearer receives extra lava damage and Weakness II Effect.\n§8§lTool Ability\n§r§a§2+ §a40â to drop a pottery sherd when mined block.\n§8§lWeapon Ability\n§r§a§2+ §aApply Slowness Effect to target, increasing effect levels(Max: VI) if hit constantly.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function BlazingGlow(player) {
    const button = new ActionFormData
    button.title("§6§lBlazing Glow")
        .body("§8§lArmour Ability\n§r§a§2+ §aFire Resistance and Night Vision.\n§2+ §aSummon an area which will damage mobs inside. Deal extra damage(+2) when soul sand or soul soil are in hotbar.\n§2+ §aGain Speed II while stepping on Blackstones and Netherracks.\n§8§lWeapon Ability\n§r§a§2+ §aApply Regeneration III to user when used to attack.\n\n\n")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Cherry(player) {
    const button = new ActionFormData
    button.title("§6§lCherry")
        .body("§8§lArmour Ability\n§r§a§2+ §aSpeed.\n§2+ §aGain Regeneration V and Saturation III when Cherry Tool or Weapon used.\n§2+ §aCreate an area called Cherry Area and damage mobs inside the area. Deal extra damage(+2) when Cherry Saplings are in hotbar.\n§2+ §aGain Speed II while stepping on Stones, Cobblestones, Deepslates, Cobbled Deepslates, Granites, Diorites and Andesites.\n§8§lTool Ability\n§r§a§2+ §aCreate an explosion when used to mine block.\n§8§lWeapon Ability\n§r§a§2+ §aCreate an explosion when used to attack.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function ChorusShulker(player) {
    const button = new ActionFormData
    button.title("§6§lChorus Shulker")
        .body("§8§lArmour Ability\n§r§a§2+ §aResistance.\n§2+ §aImmune to Levitation Effect.\n§2+ §aImmune to attack damage of Arrows, Eggs, Snowballs, Thrown Tridents\n§2+ §aGain Resistance III and Slowness when Shulker Shells are in hotbar.\n§2+ §aGain Speed II while stepping on End Stones.\n§8§lWeapon Ability\n§r§a§2+ §aGain Absorption when used to attack.\n\n")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function CopperTuff(player) {
    const button = new ActionFormData
    button.title("§6§lCopper Tuff")
        .body("§8§lArmour Ability\n§r§a§2+ §aHaste II.\n§2+ §aGain Saturation III(1s) Effect when a mob killed.\n§2+ §aWhen attacked, apply an effect called Oxidized to the target, increasing the levels when wearer apply damage to target(+1 level/attack)(Max: 4 levels). Mobs with this effect always gain Weakness Effect based on the effect levels applied(5s). When the levels reached 4 and the mobs had been attacked, the effect will be cleared and transformed into a new effect called Deoxidize, then apply to the attacker. If the attacker didn't wear Copper Tuff Armour, Weakness V Effect will be applied, if the attacker wore, Strength Effect will be applied based on the Deoxidize Effect levels(10s).\n§2+ §aGain Speed II while stepping on Stones, Cobblestones, Deepslates, Cobbled Deepslates, Granites, Diorites and Andesites.\n§4- §cWeakness I.\n§4- §cGain Hunger VIII(3s) when attacked mob.\n§8§lWeapon Ability\n§r§a§2+ §a50â to apply Weakness III(4s) Effect to target.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Creaking(player) {
    const button = new ActionFormData
    button.title("§6§lCreaking")
        .body("§8§lArmour Ability\n§r§a§2+ §aNight Vision.\n§2+ §aGain Resin Shield. Resistance III Effect will be given to wearer when Resin Shield is fully charged(20/20), the effect will remain until the Resin Shield is broken(0/20). When wearer hurt, attackers will receive damage and Wither III(4s) Effect(Wither Thorn). The charge of Resin Shield decrease(-2) when hurt. It change to 1 instead of 2 when wearer's health points is below or equal to 10.\n§2+ §aConsuming Resin Clumps, Resin Bricks(+2) and killing mobs(+4) can repair Resin Shield.\n§2+ §aIncrease Wither Thorn damage(+1) and duration of Wither Effect(+1s) when Eyeblossoms(open/closed) are in hotbar.\n§2+ §aGain Speed II while stepping on Stones, Cobblestones, Deepslates, Cobbled Deepslates, Granites, Diorites and Andesites.\n§8§lTool Ability\n§r§a§2+ §aIncrease charge of Resin Shield(+1) when mined block.\n§8§lWeapon Ability\n§r§a§2+ §aIncrease charge of Resin Shield(+1) when killed mob. 30â to apply Wither IV(6s) Effect to target.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function CrimsonWart(player) {
    const button = new ActionFormData
    button.title("§6§lCrimson Wart")
        .body("§8§lArmour Ability\n§r§a§2+ §aFire Resistance\n§2+ §aHoglins won't attack wearer.\n§2+ §aPiglins and Piglin Brutes won't attack wearer even they mined Gold Blocks and opened Chests.\n§2+ §aGain Speed II while stepping on Blackstones and Netherracks.\n§8§lTool Ability\n§r§a§2+ §a5â/15â/50â to drop Gold Block/Gold Ingot/Gold Nugget when used to mine Gold Ore, Deepslate Gold Ore or Nether Gold Ore. If the tool is enchanted with Silk Touch, then this ability won't work.\n§8§lWeapon Ability\n§r§a§2+ §a5â/15â/50â to drop Gold Nugget/Gold Ingot/Gold Block from target when used to attack.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function DragonObsidian(player) {
    const button = new ActionFormData
    button.title("§6§lDragon Obsidian")
        .body("§8§lArmour Ability\n§r§a§2+ §aGain Health Boost X, Resistance II and Strength II while staying in The End Dimension.\n§r§a§2+ §aGain Regeneration II when End Crystals are within 5 blocks.\n§2+ §aGain Speed II while stepping on End Stones.\n§4- §cGain Health Boost II, Slowness and Weakness while staying in Overworld and Nether Dimension.\n§8§lTool Ability\n§r§a§2+ §aFaster mining speed on Obsidians, Crying Obsidians and Dragon Obsidan Alloy Blocks.\n§8§lWeapon Ability\n§r§a§2+ §aDeal extra damage(+4) when hit a mob with remaining health higher than 35 health points.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Elf(player) {
    const button = new ActionFormData
    button.title("§6§lElf")
        .body("§8§lArmour Ability\n§r§a§2+ §aRegeneration.\n§2+ §aApply Regeneration I Effect to wolf within 4.5 blocks.\n§2+ §aGain Haste II when holding Elf Tool.\n§2+ §aIncrease 100 Durability and 1 Unbreaking Level.\n§2+ §aGain random effect per minute when Spore Blossoms are in hotbar.\n§2+ §aGain Speed II while stepping on Stones, Cobblestones, Deepslates, Cobbled Deepslates, Granites, Diorites and Andesites.\n§8§lTool Ability\n§r§a§2+ §aIncrease 100 Durability.\n§8§lWeapon Ability\n§r§a§2+ §aIncrease 100 Durability. Apply Regeneration to user when right clicked/long pressed.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Ember(player) {
    const button = new ActionFormData
    button.title("§6§lEmber")
        .body("§8§lArmour Ability\n§r§a§2+ §aNight Vision.\n§2+ §aGain Fire Resistance while staying in Nether Dimension. Gain Fire Resistance Effect even not in Nether Dimension when Blaze Rods are in hotbar.\n§2+ §aWearer is allowed to ride Ghasts and controlled them using Ember Weapons.\n§2+ §aWhen no any arrow and has at least one bow in wearer's hotbar, wearer will always receives an arrow. Shooting arrows will set target on fire.\n§2+ §aGain Speed II while stepping on Blackstones and Netherracks.\n§8§lWeapon Ability\n§r§a§2+ §aDeal extra damage(+4) when hit target using Ember Weapon with Fire Aspect enchantment.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function EndstoneQuartz(player) {
    const button = new ActionFormData
    button.title("§6§lEndstone Quartz")
        .body("§8§lArmour Ability\n§r§a§2+ §aStrength IV. Increase Strength Effect levels per 32 Quartzes in hotbar(Max: VI).\n§2+ §aGain Speed II while stepping on End Stones.\n§4- §cHunger X. Decrease Hunger Effect levels when there are mobs within 5 blocks.\n§8§lWeapon Ability\n§r§a§2+ §aApply an effect called Bleeding to target when used to attack.\n\n")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Flaming(player) {
    const button = new ActionFormData
    button.title("§6§lFlaming")
        .body("§8§lArmour Ability\n§r§a§2+ §aFire Resistance\n§2+ §aGain Regeneration IV while staying in lava but Weakness V Effect will be applied to wearer. Weakness Effect levels decrease when Nether Stars are in hotbar.\nSet target on fire(3s) when wearer apply damage to target.\n§2+ §aGain Speed II while stepping on Blackstones and Netherracks.\n§8§lTool Ability\n§r§a§2+ §aSet target on fire when used to attack.\n§8§lWeapon Ability\n§r§a§2+ §aSet target on fire when used to attack.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Gemmy(player) {
    const button = new ActionFormData
    button.title("§6§lGemmy")
        .body("§8§lArmour Ability\n§r§a§2+ §aRgeneration III, Resistance II, Strength II and Village Hero VI.\n§2+ §a2â to drop an extra Emerald Block when an Emerald Block mined.\n§2+ §aGain Speed II while stepping on Stones, Cobblestones, Deepslates, Cobbled Deepslates, Granites, Diorites and Andesites.\n§8§lTool Ability\n§r§a§2+ §a15â/10â/25â/15â to drop Diamond/Diamond Block/Emerald/Emerald Block when block mined.\n§8§lWeapon Ability\n§r§a§2+ §a15â/10â/25â/15â to drop Diamond/Diamond Block/Emerald/Emerald Block from target when used to attack.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function GildedAmethyst(player) {
    const button = new ActionFormData
    button.title("§6§lGilded Amethyst")
        .body("§8§lArmour Ability\n§r§a§2+ §aRegeneration and Speed.\n§2+ §aIncrease wearer's maximum health(4/12/16/24) based on the amount of Amethyst Shards(8/16/24/32+) in hotbar.\nDeal damage[(damage x 0.25) + 2] to attackers when hurt.\n§2+ §aGain Speed II while stepping on Stones, Cobblestones, Deepslates, Cobbled Deepslates, Granites, Diorites and Andesites.\n§8§lTool Ability\n§r§a§2+ §aGain Haste Effect when used to mine block.\n§8§lWeapon Ability\n§r§a§2+ §aGain Strength Effect when used to attack.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Icy(player) {
    const button = new ActionFormData
    button.title("§6§lIcy")
        .body("§8§lArmour Ability\n§r§a§2+ §aResistance.\n§2+ §aFrost Walker.\n§2+ §aApply 3 times damage(+1)(Weak Frost Damage) and 1 time damage(+8)(Strong Frost Damage) to mobs within 2.8 blocks. These damages can be affected by the following items if only one of them is in hotbar: \n§l§8> §7Ice§r§a\n§2+ §aDecrease frequency of Weak Frost Damage to 1.\n§l§8> §7Packed Ice§r§a\n§2+ §aStrong Frost Damage can be dealt to frosted mobs(mobs that took Weak Frost Damage and Strong Frost Damage), even though the mobs are out of the area. Besides, increase Weak Frost Damage to 2 and decrease Strong Frost Damage to 7.\n§l§8> §7Blue Ice§r§a\n§2+ §aStrong Frost Damage can deal 18 damage to frosted mobs but Weak Frost Damage only apply Slowness Effect to them instead of dealing 1 damage.\n§2+ §aGain Speed II while stepping on Ices, Packed Ices, Blue Ices and Frosted Ices.\n§4- §cSlowness\n§8§lWeapon Ability\n§r§a§2+ §aApply Frost Damage(1/1/1/8 damage per second) to target when used to attack.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Mana(player) {
    const button = new ActionFormData
    button.title("§6§lMana")
        .body("§8§lArmour Ability\n§r§l§8> §7Shulker Shield(Shulker Shells in hotbar)§r\n§2+ §aResistance II.\n§l§8> §7Feather Shield(Feathers in hotbar)§r\n§2+ §aImmune to fall damage.\n§l§8> §7Fire Shield(Magma Creams in hotbar)§r\n§2+ §aImmune to Small Fireballs and Fireballs damage.\n§l§8> §7Dragon Shield(Dragon's Breaths in hotbar)§r\n§2+ §aImmune to Dragon Fireballs and Shulker Bullets.\n§l§8> §7Water Shield(Pufferfishes in hotbar)§r§a\n§2+ §aWater Breathing.\n§2+ §aGain Speed II while stepping on End Stones.\n§2+ §aGive random shield every minutes if there is no any specific items in hotbar.\n§4- §cWeakness.\n§8§lWeapon Ability\n§r§a§2+ §aApply Slow Falling Effect to target when used to attack.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Oceanic(player) {
    const button = new ActionFormData
    button.title("§6§lOceanic")
        .body("§8§lArmour Ability\n§r§a§2+ §aGain Conduit Power and Speed while staying in water. Increase 1 level of the effects when Nautilus Shells are in hotbar.\n§2+ §aDolphins within 5 blocks will give wearer Absorption II Effect.\n§8§lTool Ability\n§r§a§2+ §aGain Haste IV when used to mine blocks in water.\n§8§lWeapon Ability\n§r§a§2+ §aSummon a lightning blot at target's location when used to attack.\n")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function RedstoneRock(player) {
    const button = new ActionFormData
    button.title("§6§lRedstone Rock")
        .body("§8§lArmour Ability\n§r§a§2+ §aGain Resistance IV when TNTs explode within 5 blocks. Increase the Resistance levels from IV to V when Basalts are in hotbar.\n§2+ §aGain Speed I/II/III when sprinted for 3/4/5 seconds. The effect will remain until wearer stop moving.\n§2+ §aLight up Redstone Lamps within 3 blocks when Redstone Dusts are in hotbar, also gain Night Vision Effect when the lamps are within 2 blocks.\n§8§lTool Ability\n§r§a§2+ §aGain Haste I/II/III per 15/26/51 blocks mined. The effect will remain until user stop mining.\n§8§lWeapon Ability\n§r§a§2+ §aGain Strength I/II/III/IV/V per 3/7/12/18/25 hit times. The effect will remain until user stop attacking.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Sculk(player) {
    const button = new ActionFormData
    button.title("§6§lSculk")
        .body("§8§lArmour Ability\n§r§2+ §aImmune to Darkness Effect.\n§2+ §aGain 1 Experience Point per tick.\n§2+ §aApply Darkness Effect to mobs within 5 blocks when Echo Shards are in hotbar.\n§2+ §a0.5â chance to double wearer's experience levels when killed mob.\n§2+ §aGain Speed II while stepping on Sculks, Sculk Catalysts, Sculk Sensors, Sculk Shriekers, Sculk Veins, Deepslates and Cobbled Deepslates.\n§4- §cHunger XV.\n§8§lTool Ability\n§r§a§2+ §aSummon an experience orb at user's position when block mined.\n§8§lWeapon Ability\n§r§a§2+ §aSummon an experience orb at user's position when used to attack.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Soul(player) {
    const button = new ActionFormData
    button.title("§6§lSoul")
        .body("§8§lArmour Ability\n§r§a§2+ §aResistance\n§2+ §aImmune to Slowness Effect.\n§2+ §aAlways deal damage(+7) to mobs within 5 blocks and gain Saturation X. If there is no any mob nearby, wearer will gain Hunger VI.\n§2+ §aGain Speed II while stepping on Blackstones, Netherracks, Soul Sands and Soul Soils.\n§8§lTool Ability\n§r§a§2+ §aFaster mining speed on Soul Sands, Soul Soils and Soul Alloy Blocks.\n§8§lWeapon Ability\n§r§a§2+ §aApply Wither Effect to target and Regeneration Effect to user.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Storm(player) {
    const button = new ActionFormData
    button.title("§6§lStorm")
        .body("§8§lArmour Ability\n§r§a§2+ §aJump Boost II.\n§2+ §aCreate a wind burst when wearer apply damage to target. The wind burst will knockback and damage(+2) the mobs within 2.15 blocks and apply a vertical knockback to target.\n§2+ §aApply an effect called Heavy Fall to target, dealing extra fall damage[(damage + 2) x 2].\n§2+ §aGain Speed II while stepping on Stones, Cobblestones, Deepslates, Cobbled Deepslates, Granites, Diorites and Andesites.\n§8§lWeapon Ability\n§r§a§2+ §aDeal extra damage(+2) to target that isn't on ground.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function WarpedWart(player) {
    const button = new ActionFormData
    button.title("§6§lWarped Wart")
        .body("§8§lArmour Ability\n§r§a§2+ §aFire Resistance\n§2+ §aHoglins will run away from wearer.\n§2+ §aEndermen can't be provoked when wearer looks at their eyes.\n§2+ §aGain Speed II while stepping on Blackstones and Netherracks.\n§8§lTool Ability\n§r§a§2+ §a35â chance to drop 1 to 3 Diamonds when used to mine Diamond Ore or Deepslate Diamond Ore. If the tool is enchanted with Silk Touch, then this ability won't work.\n§8§lWeapon Ability\n§r§a§2+ §aApply Slowness Effect to target when used to attack.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Watcher(player) {
    const button = new ActionFormData
    button.title("§6§lWatcher")
        .body("§8§lArmour Ability\n§r§a§2+ §aNight Vision.\n§2+ §aApply Fear Effect(10s Blindness V, Nausea IV, Slowness II and Weakness II) to mobs within 5 blocks. Increase 1 level(10s Blindness V, Nausea IV, Slowness III and Weakness III) when Eye of Enders are in hotbar. Each mob has 15 seconds cooldown after Fear Effect being applied.\n§2+ §aDamage mobs within 32 blocks based on the amount of mobs within the area when wearer hurt.\n§2+ §aGain Speed II while stepping on End Stones.\n§4- §cWeakness II.\n§8§lWeapon Ability\n§r§a§2+ §aApply Fear Effect to target when used to attack.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function WitherIron(player) {
    const button = new ActionFormData
    button.title("§6§lWither Iron")
        .body("§8§lArmour Ability\n§r§a§2+ §aHealth Boost III\n§2+ §aImmune to Wither Effect.\n§2+ §aSummon a circle and deal 4 damage to the mobs within 3 blocks. When have Wither Skeleton Skulls in hotbar, the damage and area will increase(+1 & +2) and also turn poppies within 3 blocks into wither roses. However, wearer will gain Hunger VI Effect.\n§2+ §aGain Speed II while stepping on Blackstones and Netherracks.\n§8§lWeapon Ability\n§r§a§2+ §aKilling Wither Skeletons will have 10â chance to drop an extra Wither Skeleton Skull.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Equipment(player);
        if (selection.canceled) return;
    })
};
function Alloys(player) {
    const button = new ActionFormData
    button.title("§6§lAlloys")
        .body("§8By using Alloys, player can make powerful gears including armours, swords and tools in Equipment Workbenches.\n\n\n\n\n\n\n\n\n\n\n\n")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            AlloysMenu(player);
        if (selection.canceled) return;
    })
};
function Blocks(player) {
    const button = new ActionFormData
    button.title("§6§lBlocks")
        .button("§3Alloy Blocks", "textures/blocks/warped_wart_alloy_block")
        .button("§3Alloys Maker", "textures/blocks/alloys_maker_up")
        .button("§3Equipment Workbench", "textures/blocks/equipment_workbench_up")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            AlloyBlocks(player);
        if (selection.selection == 1)
            AlloysMaker(player);
        if (selection.selection == 2)
            EquipWorkbench(player);
        if (selection.selection == 3)
            AlloysMenu(player);
        if (selection.canceled) return;
    })
};
function AlloyBlocks(player) {
    const button = new ActionFormData
    button.title("§6§lAlloy Blocks")
        .body("§8Make using 9 alloy ingots in Crafting Table. Can only be used for decoration. Required at least diamond tier pickaxes to break.\n\n\n\n\n\n\n\n\n\n\n\n")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Blocks(player);
        if (selection.canceled) return;
    })
};
function AlloysMaker(player) {
    const button = new ActionFormData
    button.title("§6§lAlloys Maker")
        .body("§8A crafting table which can be used to craft alloys. To craft an alloy, player needs 2 or 3 different ingredients and a Netherite Ingot. Required at least wooden tier pickaxes to break.\n\n\n\n\n\n\n\n\n")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Blocks(player);
        if (selection.canceled) return;
    })
};
function EquipWorkbench(player) {
    const button = new ActionFormData
    button.title("§6§lEquipment Workbench")
        .body("§8A crafting table which can be used to craft gears made with alloys. Player needs a pattern and an alloy then put them in equipment workbench to craft gears wanted. To craft a pattern, player needs 4 iron ingots and a piece of iron equipment e.g. use iron chestplate to craft a chestplate pattern. Required at least wooden tier pickaxes to break.\n\n\n")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            Blocks(player);
        if (selection.canceled) return;
    })
};
function Changelog1(player) {
    const button = new ActionFormData
    button.title("§6§lV8.0 Changelog")
        .body("§s-This addon only supported Minecraft Bedrock versions 1.21.60+.\n§3§lAdds:\n§r§s-Added a new description for Ancient Alloys so that players can know the way to obtain it.\n-Added 'Changelog' category into Alloys Forging Book.\n-Added Copper Tuff Alloys, Creaking Alloys, Storm Alloys and their equipment and alloy blocks.\n-Added Golden Bone Swords and Golden Greatswords.\n-Added some cool description for each alloy.\n§3§lChanges:\n§r§s-35â chance to drop 1 to 3 Diamonds when Diamond Ore/Deepslate Diamond Ore was mined using Warped Wart Pickaxes.\n-Abilities that will directly give players items are now changed to drop items at the location of blocks or mobs.\n-Added Diamond Blocks and Emerald Blocks into 'gemmy' loot table and removed Gold Ingots.\n-Added Flow Pottery Sherds, Guster Pottery Sherds and Scrape Pottery Sherds into 'sherd' loot table.\n-Added tags for Alloys Armours:\n>minecraft:is_armor\n>minecraft:netherite_tier\n>minecraft:trimmable_armors\n-Added tag for Alloys Forging Books:\n>minecraft:bookshelf_books\n-Added tag for Alloy Tools and Weapon:\n>minecraft:netherite_tier\n-Alloy Blocks were separated to a group called 'Alloy Blocks' in construction category.\n-Alloy Blocks are now required at least diamond tier pickaxes to break.\n-Alloy Blocks are now uncommon rarity instead of common rarity. \n-Alloys Forging Books: \n>Changed the content to make it easier to understand.\n>Moved Bad Omen III in Ancient category from positive abilities(+) to negative abilities(-).\n-Alloys Makers and Equipment Workbenches are now required at least wooden tier pickaxes to break.\n-Alloys were separated to a group called 'Alloys' in items category.\n-Ancient Alloys are now more easily to be obtained from Trail Ruins.\n-Armour Trims can be applied to Alloy Armours.\n-Chance of dropping Pottery Sherds when blocks mined using Ancient Tools are now change to 40â instead of 100â.\n-Changed recipes of Alloys Makers and Equipment Workbenches:\n>Chiseled Deepslates, Cracked Deepslate Bricks, Cracked Deepslate Tiles, Deepslate Bricks and Deepslate Tiles can now be used in the recipes to replace Polished Deepslates.\n>Deepslates can now be used in Equipment Workbench recipe to replace Cobbled Deepslates.\n-Changed the following effects provided by Gemmy Armour:\n>Resistance I -> Resistance II\n>Village Hero V -> Village Hero VI\n-Changed the random effect provided by Elf Armour: \n>Conduit Power II -> Conduit Power III.\n>Haste I -> Haste II.\n>Saturation I -> Saturation III.\n>Speed I -> Speed II.\n>Village Hero III -> Village Hero IV.\n-doMobLoot and doTileDrops gamerules will now affect the abilities of all Alloy Tools and Weapons.\n-Gemmy Armours will now provide a new ability which enable wearer to have 2â to get an extra Emerald Block when mined an Emerald Block.\n-Increased Alloy Armours protection:\n>Helmet: 3 -> 6\n>Chestplate: 8 -> 10\n>Leggings: 6 -> 8\n>Boots: 3 -> 6\n-Increased Alloy Blocks destroy time without any pickaxe from 3.2 seconds to 10.6 seconds.\n-Mobs can't equip Alloy Armours via dispensers.\n-Patterns were separated to a group called 'Patterns' in items category.\n-Removed 'anc_tool.mcfunction', 's_tool.mcfunction' and 'warp_tool.mcfunction'.\n-Renamed 'magic_obsidian.mcfunction' to 'dragon_obsidian.mcfunction'.\n-Renamed 'Sculk Steel Alloy Block' to 'Sculk Steel Block' and changed its id from 'alloys: sculk_steel_alloy_block' to 'alloys: sculk_steel_block'.\n-Sculk Armours now has 0.5â to double wearer's experience levels.\n-Vanilla pickaxes can now mine alloy blocks faster.\n-Watcher Armours will now damage mobs within 32 blocks based on the amount of mobs within the area when wearer hurt.\n-Wither Skeletons killed using Wither Iron Sword, Wither Iron Bone Sword or Wither Iron Greatsword will now have 10â chance of dropping extra Skeleton Skull instead of 16.67â.\n§3§lFixes:\n§r§s-Alloy Blocks, Alloy Makers and Equipment Workbench will now show on maps.\n-Gilded Amethyst Armours will no longer decrease wearer's main hand items durability when hurt.\n-Fixed a bug where the descriptions in Alloy Forging Books are missing.")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            AlloysMenu(player);
        if (selection.canceled) return;
    })
};
function Changelog2(player) {
    const button = new ActionFormData
    button.title("§6§lV8.1 Changelog")
        .body("§s-This addon only supported Minecraft Bedrock versions 1.21.60+.\n§3§lChanges:\n§r§s-Changed Pickaxes, Axes, Shovels, Hoes, Swords and Greatswords texture.\n-Changed Swords attack damage from 10 to 11 and Greatswords attack damage from 15 to 14.\n\n\n\n\n\n")
        .button("               §3Back")
    if (player);
    button.show(player).then((selection) => {
        if (selection.selection == 0)
            AlloysMenu(player);
        if (selection.canceled) return;
    })
};